﻿using System;
using System.Collections.Generic;
using System.Text;

namespace AbstractFactory
{
    class Program
    {
        static void Main(string[] args)
        {
            DataAccess.GetDepartment();

            DataAccess.GetUser();

            Console.ReadLine();
        }
    }

    interface IUser
    {
        void GetUser();
    }

    class SUser : IUser
    {
        #region IUser 成员

        public void GetUser()
        {
            Console.WriteLine("SUser GetUser");
        }

        #endregion
    }

    class AUser : IUser
    {
        #region IUser 成员

        public void GetUser()
        {
            Console.WriteLine("AUser GetUser");
        }

        #endregion
    }

    interface IDepartment
    {
        void GetDepartment();
    }

    class SDepartment : IDepartment
    {

        #region IDepartment 成员

        public void GetDepartment()
        {
            Console.WriteLine("SDepartment");
        }

        #endregion
    }

    class ADepartment : IDepartment
    {

        #region IDepartment 成员

        public void GetDepartment()
        {
            Console.WriteLine("ADepartment");
        }

        #endregion
    }

    class DataAccess
    {
        private static string ass = "a";

        public static void GetUser()
        {
            IUser user;
            switch (ass)
            { 
                case "s":
                    user = new SUser();
                    break;
                case "a":
                    user = new AUser();
                    break;
                default:
                    user = new SUser();
                    break;
            }
            user.GetUser();
        }

        public static void GetDepartment()
        {
            IDepartment department;
            switch (ass)
            {
                case "s":
                    department = new SDepartment();
                    break;
                case "a":
                    department = new ADepartment();
                    break;
                default:
                    department = new SDepartment();
                    break;
            }
            department.GetDepartment();
        }
    }
}
