﻿using System;
using System.Collections.Generic;
using System.Text;

namespace Factory
{
    class Program
    {
        static void Main(string[] args)
        {
            IFactory fac=new AddFactory();
            Operation oper = fac.CreateOperation();
            oper.parm1 = 123;
            oper.parm2 = 456;
            Console.WriteLine("result:{0}",oper.GetResult());

            fac = new SubFactory();
            oper = fac.CreateOperation();
            oper.parm1 = 123;
            oper.parm2 = 456;
            Console.WriteLine("result:{0}",oper.GetResult());

            Console.ReadLine();
        }
    }

    class Operation
    {
        public double parm1
        {
            get;
            set;
        }

        public double parm2
        {
            get;
            set;
        }

        public virtual double GetResult()
        {
            return 0;
        }
    }

    class AddOPeration : Operation
    {
        public override double GetResult()
        {
            return parm1 + parm2;
        }
    }

    class SubOPeration : Operation
    {
        public override double GetResult()
        {
            return parm1 - parm2;
        }
    }

    class MulOPeration : Operation
    {
        public override double GetResult()
        {
            return parm1 * parm2;
        }
    }

    class DivOPeration : Operation
    {
        public override double GetResult()
        {
            if (parm2 == 0)
            {
                return 0;
            }
            return parm1 / parm2;
        }
    }

    interface IFactory
    {
        Operation CreateOperation();
    }

    class AddFactory : IFactory
    {

        #region IFactory 成员

        public Operation CreateOperation()
        {
            return new AddOPeration();
        }

        #endregion
    }
    class SubFactory : IFactory
    {

        #region IFactory 成员

        public Operation CreateOperation()
        {
            return new SubOPeration();
        }

        #endregion
    }
    class MulFactory : IFactory
    {

        #region IFactory 成员

        public Operation CreateOperation()
        {
            return new MulOPeration();
        }

        #endregion
    }
    class DivFactory : IFactory
    {

        #region IFactory 成员

        public Operation CreateOperation()
        {
            return new DivOPeration();
        }

        #endregion
    }

    
}
