﻿using System;
using System.Collections.Generic;
using System.Text;
using System.Collections;

namespace Prototype
{
    class Program
    {
        static void Main(string[] args)
        {
            ColorManager cm = new ColorManager();
            cm["abc"] = new Color(222, 111, 0);
            cm["abc"] = new Color(222, 111, 0);
            cm["cde"] = new Color(123, 41, 53);
            cm["abc1"] = cm["abc"].Clone() as Color;
            cm["cde1"] = cm["cde"].Clone() as Color;
            Console.WriteLine(cm["abc1"].ToString());
            Console.WriteLine(cm["cde1"].ToString());


            Console.ReadLine();

        }
    }

    class Color
    {
        int red = 0;
        int green = 0;
        int blue = 0;

        public Color(int r, int g, int b)
        {
            red = r;
            green = g;
            blue = b;
        }

        public Color Clone()
        {
            Console.WriteLine("Cloneing {0,3},{1,3},{2,3}", red, green, blue);
            return (Color)this.MemberwiseClone();//浅拷贝
        }

        public override string ToString()
        {
            return string.Format("Attribute:{0,3},{1,3},{2,3}", red, green, blue);
        }
    }

    class ColorManager
    {
        Hashtable colors = new Hashtable();

        public Color this[string name]
        {
            get
            {
                return colors[name] as Color;
            }
            set
            {
                colors[name]=value;
                //colors.Add(name, value);
            }
        }

    }
}
